"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = exports.program = exports.goBack = exports.push = exports.history = void 0;
const rxjs_1 = require("rxjs");
const pipeable_1 = require("fp-ts/lib/pipeable");
const R = __importStar(require("fp-ts-rxjs/lib/Observable"));
const T = __importStar(require("fp-ts/lib/Task"));
const sub = __importStar(require("./Sub"));
const html = __importStar(require("./Html"));
const Cmd_1 = require("./Cmd");
function history(history) {
    return {
        location: history.location,
        push: url => () => {
            const [pathname, search] = url.split('?');
            history.push({ pathname, search });
        },
        back: () => history.back(),
        listen: f => () => history.listen(f)
    };
}
exports.history = history;
exports.push = (url) => Cmd_1.perform_(env => T.fromIO(env.history.push(url)));
exports.goBack = () => Cmd_1.perform_(env => T.fromIO(env.history.back));
function program(locationUpdateToMessage, init, update, view, subscriptions = sub.none) {
    const monoidSubR = sub.getMonoid();
    return env => {
        const update$ = new rxjs_1.Subject();
        const onChangeLocation = sub.fromObservable(pipeable_1.pipe(update$, R.map(locationUpdateToMessage)));
        const subs = monoidSubR.concat(subscriptions, onChangeLocation);
        return Object.assign(Object.assign({}, html.program(init(env.history.location), update, view, subs)(env)), { listen: env.history.listen(update => update$.next(update)) });
    };
}
exports.program = program;
function run(program, renderer, env) {
    const p = program(env);
    p.listen();
    return html.run(() => p, renderer, env);
}
exports.run = run;
//# sourceMappingURL=Navigation.js.map